kernel: Remove unused KTR_POLLING option.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.3 to later versions                +
13 +-----------------------------------------------------------------------+
14
15 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
16 ---------------------------------------------------------------------------
17
18 The DEVICE_POLLING kernel option has been made a no-op and it has been
19 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
20 kernel config, you need to change it to IFPOLL_ENABLE.
21
22 Also, the KTR_POLLING kernel option has been removed, so it must be
23 removed from kernel configs that have it.
24
25 +-----------------------------------------------------------------------+
26 +         UPGRADING DRAGONFLY FROM 3.2 to later versions                +
27 +-----------------------------------------------------------------------+
28
29 SMP OPTION REMOVED
30 ------------------
31
32 The SMP kernel option has been made a no-op. All kernels now feature SMP
33 support. If you have 'options SMP' in your kernel config, you can as well
34 remove it.
35
36 +-----------------------------------------------------------------------+
37 +         UPGRADING DRAGONFLY FROM 3.0 to later versions                +
38 +-----------------------------------------------------------------------+
39
40 APIC_IO OPTION REMOVED
41 ----------------------
42
43 The APIC_IO kernel option is no longer accepted after having been without
44 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
45 If you have 'options APIC_IO' in your kernel config, you'll have to
46 remove it.
47
48 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
49 -----------------------------------------
50
51 The wdog framework is now compiled into our kernels by default, so the
52 options are no longer needed.
53
54 DOSCMD(1) REMOVED
55 -----------------
56
57 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
58 NO_X make.conf option was removed too.
59
60 GCC 4.7
61 -------
62
63 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
64 default compiler in base (default is still GCC 4.4).
65
66 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
67 NO_GCC47 in /etc/make.conf.
68
69 USB4BSD
70 -------
71
72 A new USB stack (from FreeBSD) has been brought in. The following
73 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
74 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
75 and uaudio.
76
77 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
78 be put in make.conf and device "usb4bsd" (quotes needed) has to
79 replace device usb in the kernel config. After that, a full
80 build/install/upgrade cycle is needed.
81
82 Note that this is experimental and incomplete, but we are interested
83 in hearing about issues with it, of course.
84
85 +-----------------------------------------------------------------------+
86 +         UPGRADING DRAGONFLY FROM 2.10 to later versions               +
87 +-----------------------------------------------------------------------+
88
89 SEVERAL ISA DRIVERS REMOVED
90 ---------------------------
91
92 The following ISA only drivers have been removed along with a couple of
93 associated userland tools:
94
95 aha(4)
96 asc(4) & sasc(1)
97 ctx
98 dgb(4)
99 el(4)
100 gpib
101 gsc(4) & sgsc(1)
102 ie(4)
103 labpc(4)
104 le(4)
105 mse(4)
106 rc(4)
107 rdp(4)
108 spigot
109 tw(4) & xten(1) & xtend(8)
110 wl(4) & wlconfig(8)
111 wt(4)
112
113 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
114 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
115 file.
116
117 If buildkernel complains about any of these drivers, just remove them
118 from your kernel configuration.
119
120 BINUTILS 2.20
121 -------------
122 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
123 values of BINUTILSVERS are now binutils221 and binutils222 (default).
124
125 BUILDWORLD/-KERNEL PARALLELIZATION WORK
126 ---------------------------------------
127 Due to changes in the way we build with more than one make job, you
128 will have to update install(1) and mkdir(1) prior to buildworld if you
129 want to build with 'make -j':
130
131 cd /usr/src/usr.bin/xinstall; make; make install; make clean
132 cd /usr/src/bin/mkdir; make; make install; make clean
133
134 DMA(8) UPGRADE
135 --------------
136 dma(8) has been upgraded to v0.7 which no longer supports the
137 /etc/dma/virtusertable. Some of its functionality has been replaced
138 with the MASQUERADE keyword and the EMAIL environment variable (see
139 the dma(8) manual page).
140
141 +-----------------------------------------------------------------------+
142 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
143 +-----------------------------------------------------------------------+
144
145 GCC 4.4 & BINUTILS 2.21
146 -----------------------
147
148 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
149 been made DragonFly's default Binutils.
150
151 That means that any settings that set CCVER to 'gcc44' are not needed
152 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
153 GCC 4.1.
154
155 It also means that 'binutils221' as a value for BINUTILSVER has no
156 effect anymore. 2.17 has been removed and 'binutils220' is available
157 as an option.
158
159 The NO_GCC44 option has been removed and will not affect the build
160 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
161 building in a similar fashion.
162
163 Note that you must do a full buildworld/buildkernel for upgrading.
164
165 pkg_radd settings
166 -----------------
167
168 The config file for pkg_radd has moved from /etc/settings.conf to 
169 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
170 if this is needed.  This warning only applies if /etc/settings.conf 
171 exists.  pkg_radd will continue to work with defaults.
172
173 +-----------------------------------------------------------------------+
174 +         20100927                                                      +
175 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
176 +-----------------------------------------------------------------------+
177
178 OpenSSL
179 --------
180
181 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
182 This shouldn't break any 3rd-party software, but you'll need to recompile your
183 3rd-party software if you want it to link against the new version of OpenSSL.
184
185 Loader
186 -------
187
188 A new loader (dloader) has been added which better handles booting from
189 multiple kernel/module versions.
190
191 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
192
193         cd /usr/src
194         make buildworld
195         make installworld
196         make upgrade
197         make buildkernel KERNCONF=<KERNELNAME>
198         make installkernel KERNCONF=<KERNELNAME>
199
200 Note that you must installworld and run the 'upgrade' target before
201 installing the new kernel.
202
203 BIND
204 -----
205
206 BIND has been removed from the base system.  The ldns and drill tools have 
207 been added for basic functionality.  Use 'drill' where you would normally 
208 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
209 net/bind95, net/bind96, or net/bind97 as of this writing.
210
211 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
212 include BIND as a pkgsrc package.
213
214 +-----------------------------------------------------------------------+
215 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
216 +                               GENERAL                                 +
217 +-----------------------------------------------------------------------+
218
219 Instructions on how to obtain and maintain DragonFly source code using git
220 are in the development(7) manual page.
221
222 To upgrade a DragonFly system from sources you run the following sequence:
223
224         cd /usr/src
225         make buildworld
226         make buildkernel KERNCONF=<KERNELNAME>
227         make installkernel KERNCONF=<KERNELNAME>
228         make installworld
229
230 You will also want to run the 'upgrade' target to upgrade your /etc and the
231 rest of your system.  The upgrade target is aware of stale files created by
232 older DragonFly installations and should delete them automatically.
233
234         make upgrade
235
236 See the build(7) manual page for further information.
237
238 Once you've done a full build of the world and kernel you can do incremental
239 upgrades of either by using the 'quickworld' and 'quickkernel' targets
240 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
241 the quick targets, try updating your repo first, and then a full buildworld
242 and buildkernel as shown above, before asking for help.
243
244 +-----------------------------------------------------------------------+
245 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
246 +-----------------------------------------------------------------------+
247
248 In 2.1 kernel and modules has moved to boot directory.  For most cases
249 this is handled automatically by 'make upgrade'.  A few cases needs manual
250 intervention:
251
252  * When installing a kernel without first doing a make buildworld,
253    installworld and upgrade to the same DESTDIR as kernel:
254    make DESTDIR/boot directory and move kernel and modules into this boot
255    directory; also move kernel.old and modules.old.
256    Typical example is vkernel(7), use (no modules used):
257
258         cd /var/vkernel
259         mkdir boot
260         chflags noschg kernel
261         mv kernel kernel.old boot
262         chflags schg boot/kernel
263         
264  * When using a boot-only partition, /boot/loader.rc needs to be edited:
265    delete occurrences of '/boot/'.
266    These occurences can normally be deleted in any case, see loader(8).
267
268 +-----------------------------------------------------------------------+
269 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
270 +-----------------------------------------------------------------------+
271
272 In 1.9 major changes to the disk management infrastructure have taken
273 place.  make upgrade may not catch all of your disk devices in /dev,
274 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
275 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
276 and MAKEDEV no longer exists.
277
278 The biggest changes in 1.9 are:
279
280 (1) That whole-slice devices such as da0s1 no longer share the same device
281     id as partition c devices such as da0s1c.
282
283 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
284     with no snooping or reserved sectors.  Consequently you cannot run
285     disklabel on this device.  Instead you must run disklabel on a
286     whole-slice device.
287
288 (3) The 'compatibility' partitions now use slice 0 in the device name,
289     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
290     accessing the disklabel for the compatibility partitions must be
291     done via slice 0 (da0s0).
292
293 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
294     and CCD now run through the disk management layer and are assigned
295     real disk management devices.   VN and CCD in particular do not usually
296     use a MBR and disklabels must be accessed through the compatibility
297     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
298     don't name it 'ccd0s0' in the config file.
299
300 Generally speaking, you have to get used to running fdisk and disklabel on
301 the correctly specified device names.  A lot of the wiggle, such as running
302 disklabel on a partition, has been removed.
303
304 +-----------------------------------------------------------------------+
305 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
306 +-----------------------------------------------------------------------+
307
308 > Kerberos IV
309 -------------
310
311 Kerberos IV (eBones) was removed from the tree, please consider moving to
312 Kerberos 5 (Heimdal).
313
314 > Package Management System
315 ---------------------------
316
317 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
318 management system.  The necessary tools to build and maintain packages
319 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
320 directories are in your PATH variable.
321
322 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
323 the tarball from NetBSD:
324
325         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
326         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
327
328 This tree can then be kept up to date with cvs update:
329
330         cd /usr/pkgsrc; cvs up
331
332 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
333 build and install the pkgsrc bootstrap manually:
334
335         cd /usr/pkgsrc/bootstrap
336         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
337
338 +-----------------------------------------------------------------------+
339 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
340 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
341 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
342 +-----------------------------------------------------------------------+
343
344 The compatibility shims for the build environment have been removed, you
345 have to update to DragonFly 1.2 release branch first.
346
347 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
348 The existing configuration can be converted using /etc/pam.d/convert.sh.
349 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
350 the pam_skey.so module was retired, you have to remove it manually from
351 your configuration, when you convert it.
352
353 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
354 ---------------------
355
356 The following users may be missing from your password file.  Use vipw and
357 add any that are missing:
358
359 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
360 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
361
362 The following groups may be missing from your group file.  Use vi /etc/group
363 and add any that are missing:
364
365 smmsp:*:25:
366 authpf:*:63:
367 _pflogd:*:64:
368
369
370 > Upgrading to DragonFly from FreeBSD
371 ---------------------
372
373 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
374 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
375 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
376 make depend information, it starts from scratch, so no pre-cleaning of the
377 object hierarchy is necessary.
378
379         # get the CVS repository (it is placed in /home/dcvs, 500MB).
380         # Please use the -h option and a mirror site to pull the 
381         # initial repository, but feel free to use the main repository
382         # machine to pull updates.
383         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
384         # install the source from the CVS hierarchy (remove preexisting
385         # FreeBSD src first) (500MB)
386         cd /usr
387         rm -rf src
388         cvs -R -d /home/dcvs checkout -P src
389
390         # build it (500MB used in /usr/obj)
391         #
392         cd /usr/src
393         make buildworld
394         make buildkernel KERNCONF=<KERNELNAME>
395
396 Once you have built DragonFly you have to install it over FreeBSD.  Since
397 DragonFly does not track changes made by FreeBSD to its include file 
398 hierarchy and include file pollution can cause all sorts of unexpected
399 compilation issues to come up, it is best to wipe your include hierarchy
400 prior to installing DragonFly.  Note that you should not wipe any installed
401 FreeBSD header files or binaries until after you have successfully completed
402 the build steps above.
403
404         rm -rf /usr/include
405         mkdir /usr/include
406         make installkernel KERNCONF=<KERNELNAME>
407         make installworld
408
409 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
410 will unconditionally upgrade the /etc files that sysops do not usually
411 mess around with, such as the files in /etc/rc.d.  It will also remove any
412 obsolete files such as utilities and manpages that have been removed from
413 the system since the version you're coming from.  If you are unsure we 
414 recommend that you make a backup of at least your /etc before applying
415 this step.  Note that DragonFly's RC system is basically RCNG from
416 FreeBSD-5, but there are some differences in the contents of the RC files.
417
418         make upgrade
419
420 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
421 Doing so might leave your system in an unusable state.
422
423 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
424 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
425 report these files to the DragonFly developers so that they can be added to
426 the 'upgrade' target.
427